/*================================================================================*/
/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> COM_IAR.H <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
/*================================================================================*/
#include		<stdio.h>
#include		<ctype.h>
#include		<fcntl.h>
#include		<math.h>
#include		<string.h>
#include		<stdlib.h>
#include		<unistd.h>
#include		<sys/types.h>


/*DOS DEFINED BUT NOT IN UNIX*/
/*
#include		<io.h>
#include		<conio.h>
#include		<dos.h>
#include		<sys/stat.h>
#include		<bios.h>
#include		<alloc.h>
*/

/*DEFINED IN DOS BUT NOT IN UNIX*/
#define O_BINARY		0

#define CMT_LEN			200
#define FLNM_LEN		50

#define JB_ERGMULT_2_LONG	1.0e3
#define JB_ITNMULT_2_SHORT	1.0e3

#define S_RT_FIN	        0
#define S_RT_P1		        1
#define S_RT_P2		        2
#define S_RT_P3		        3
#define S_RT_P4		        4
#define E_RT_ILG	        5
#define E_RT_LLG		6
#define E_RT_NCL		7
#define E_RT_NOL		8
#define E_RT_KLL		9
#define E_RT_PNF		10
#define E_RT_PNO		11
#define E_RT_NRC		12
#define E_RT_UNK		13

#define ST_NO			2
#define GND			0
#define EXE			1

#define ST_NOPARORI		16
#define ST_NOPAR		15
#define A   			0
#define B   			1
#define C   			2
#define PX  			3
#define PY  			4
#define PZ  			5
#define PXPY  			6
#define PXPZ  			7
#define PYPZ	  		8
#define DK  	  		9
#define DJK  	  		10
#define DJ  	  		11
#define dK  	  		12
#define dJ  	  		13
#define PZ3  	  		14
#define ORI	  		15

#define PHI	0
#define THE	1
#define CHI	2

#define A_TYPE			1
#define B_TYPE			2
#define C_TYPE			3
#define AB_TYPE			4
#define AC_TYPE			5
#define BC_TYPE			6


#define PIE			(4.0 * atan( 1.0 ))
#define DEG_2_RAD		(2.0 * PIE / 360.0)

/*CONVERSION CONSTANT FROM TEMPERATURE IN K TO TEMPERATURE IN MHZ*/
#define BOLTZMANN		(1.380658e-23 * 1.0e-6 / 6.6260255e-34)

/*CONVERSION CONSTANT FROM/TO MHZ TO/FROM AMU * ANGSTRUMS ** 2*/
#define ERG_2_MKS		505379.0765


extern float IAR_version ;
extern short JB_stat ;
extern double JB_ergfactor, JB_itnfactor, JB_fsr ;

extern short Err ;
extern short Im_stat ;

extern char Mol_nm[ CMT_LEN ], Out_flnm[ FLNM_LEN ], Cg_flnm[ FLNM_LEN ] ;
extern char See_flnm[ ST_NO ][ FLNM_LEN ], Sqn_flnm[ ST_NO ][ FLNM_LEN ], Sdv_flnm[ ST_NO ][ FLNM_LEN ] ;
extern char Sevr_flnm[ ST_NO ][ FLNM_LEN ], Sevi_flnm[ ST_NO ][ FLNM_LEN ] ;

extern char St_str[ ST_NO ][ FLNM_LEN ] ;
extern char Band_chr[ FLNM_LEN ], Band_str[ FLNM_LEN ] ;
extern short Band_type, A_type, B_type, C_type ;
extern short Amp_stat, Amp_no ;

extern double A_prj, B_prj, C_prj ;

extern FILE *Log_fp ;
extern long J_max, Dk_order ;

extern char Rc_str[ ST_NOPARORI ][ FLNM_LEN ] ;
extern short St_nodv[ ST_NO ] ;
extern short Rc_stat[ ST_NO ][ ST_NOPARORI ], Tp_stat[ ST_NO ][ ST_NOPARORI ] ;
extern double Rc[ ST_NO ][ ST_NOPARORI ], Tp[ ST_NO ][ ST_NOPARORI ], Rc_sd[ ST_NO ][ ST_NOPARORI ] ;
extern double Kap[ ST_NO ] ;

extern short Ka_parity, Kc_parity, Parity_stat ;
extern short *Ka_ary[ ST_NO ], *Kc_ary[ ST_NO ] ;

extern double *Erg_vec[ ST_NO ] ;
extern double Temp, Itn_cut ;

extern double Hp_mat[ ST_NO ][ 3 ][ 3 ] ;
extern double The_dc[ ST_NO ], Phi_dc[ ST_NO ], Chi_dc[ ST_NO ] ;
extern double HamRot_mat[ ST_NO ][ 3 ][ 3 ] ;

extern long Prt_ee[ ST_NO ], Prt_ev[ ST_NO ] ;


extern char Asn_flnm[ FLNM_LEN ] ;
extern long *Aqn_vec ;
extern double *Aerg_vec ;
extern long Asn_jmax, Asn_kmax ;
extern long Asn_nolvs, Acp_nolvs, Rej_nolvs ;

extern long Trs_nolvs ;

extern int Se_fd, Ee_fd, Si_fd, Bt_fd, Jk_fd, Dv_fd, Lf_fd ;

extern short Lsf_noprm, Lsf_stat[ ST_NO ][ ST_NOPARORI ], Lsf_ecycs, Lsf_acycs, Lsflc_stat ;
extern double Lsf_rejlv ;
extern float Omc_stdv ;

extern short Dual_Fit ;
extern double Lsf_UVwt, Lsf_MWwt ;




/*
#define PI			3.141592653589793238462643383
void exit() ;
char *strcat() ;
char *strcpy() ;
double sqrt() ;
long lseek() ;

double pow(), sqrt(), exp(), fabs(), sin(), cos(), tan() ;
*/


